\documentclass[a4paper,10pt]{article}
\usepackage[utf8]{inputenc}
\usepackage[english]{babel}

\usepackage{amsmath}
\usepackage{amsthm}
\usepackage{amssymb}
\usepackage{fullpage}
\usepackage{subfig}
\usepackage{url}
\usepackage[colorlinks=true,linkcolor=blue,urlcolor=blue,citecolor=blue,anchorcolor=blue]{hyperref}

\usepackage{pgf}
\usepackage{tikz}
\usetikzlibrary{shapes.geometric}
\usetikzlibrary{arrows,positioning,calc,fit,automata,shapes.multipart}

\theoremstyle{definition}
\newtheorem{definition}{Definition}
\theoremstyle{definition}
\newtheorem{tr}{TR}
\theoremstyle{definition}
\newtheorem{wfr}{WFR}
\theoremstyle{definition}
\newtheorem{pt}{Pattern}

\newcommand{\trs}[5]{#1 \xrightarrow[#5]{#3\ #4} #2}
\newcommand{\red}[1]{\textcolor{red}{#1}}

\usepackage{semantic}

\usepackage{listings}
\lstset{ %
  basicstyle=\ttfamily\small,        % \ttfamily\footnotesize the size of the fonts that are used for the code
  breakatwhitespace=false,         % sets if automatic breaks should only happen at whitespace
  breaklines=true,                 % sets automatic line breaking
  columns=fullflexible,
  %captionpos=b,                    % sets the caption-position to bottom
  extendedchars=true,              % lets you use non-ASCII characters; for 8-bits encodings only, does not work with UTF-8
  frame=none,	                   % adds a frame around the code
  %keepspaces=true,                 % keeps spaces in text, useful for keeping indentation of code (possibly needs columns=flexible)
  showstringspaces=false,
  keywordstyle=\color{blue},       % keyword style
  %language=C,                 % the language of the code
  tabsize=2,	                   % sets default tabsize to 2 spaces
  %title=\lstname,                   % show the filename of files included with \lstinputlisting; also try caption instead of title
  belowskip=5pt,
  aboveskip=5pt
}

%\usepackage{authblk}

\title{Formalization of TASTE Designs as Networks of Timed Automata in BIP}
\author{Iulia Dragomir$^1$ ~~~~ Arnaud Schach$^2$ ~~~~ Pierre Dissaux$^2$ ~~~~ Saddek Bensalem$^1$\\[1ex]
\small$^1$Verimag, France ~~~~  
	$^2$Ellidiss Technologies, France}
\date{31/08/2018}

\begin{document}


\maketitle

\section{Introduction}
\label{sec:intro}

TASTE \cite{ConquetPDTH10,PerrotinCDST11,PerrotinCDT12} is a framework for the design of heterogeneous reactive embedded systems. The framework consists of a ``language'' formed by well 
established modeling formalisms and programming languages, and a tool-chain for different types of analysis and code generation. More specifically, a system in TASTE  is an AADL \cite{AADL} 
component-based diagram, where each component's behavior is modeled/coded accordingly. For instance, TASTE recommends to model system overall orchestration and logic with SDL \cite{SDL}, 
to model control components in Simulink\footnote{\url{https://www.mathworks.com/products/simulink.html}}, and to code drivers in C. With respect to the tool-chain, TASTE performs 
well-formedness and typing analysis on the system components, checks the real-time scheduling of the system and, generates code for the specified hardware (i.e., deployment). 
Code generation is the most important feature of TASTE as it tackles the interactions between the components and the exchanged data. The generated glue encodes and decodes the 
transferred data defined in ASN.1 \cite{ASN}, which makes it a tool suitable for co-simulation. Additionally, code generation brings simulation, debugging and testing functionalities for a system.

However, the rich language of TASTE is also an inconvenient as it is based on many semi-formal languages which can introduce errors in the design due to the different interpretations by engineers.
Catching these errors is done a posteriori through testing, which is known to be incomplete. Incorporating a rigorous design approach based on formal methods could have great benefits.
We propose in this paper the use of BIP \cite{BasuBS06} for rigorous system design in TASTE: formal representation of the system as Timed Petri Net/Timed Automata \cite{AlurD94}, 
scalable validation and verification methods and tools on the formal model and correct-by-construction transformations of the model towards code. 

%Language embedding concerns the use of BIP as a unifying semantic model for structural representation of different programming models or domain specific languages. 
We have previously developed a general method for generating BIP models from languages with well-defined operational semantics.
Depicted in Fig.~\ref{fig:method_embedding}, the method involves the following three steps for a given application software written in a generic language $L$:
\begin{enumerate}
	\item Translation of atomic components of the source language into BIP components. The translation focuses on the definition of adequate interfaces for the component. 
		It also encapsulates and reuses data structures and functions of the application software.
	\item Translation of coordination mechanisms between components of the application software into connectors and priorities in the target BIP model.
	\item Generation of a BIP component modeling the operational semantics of $L$. This component plays the role of an engine coordinating the execution of the application software components.
\end{enumerate}

\begin{figure}[h]
	\centering
	\begin{tikzpicture}
		\node[draw, rectangle, rounded corners] (c1) {
			\begin{tikzpicture}
				\node[draw, rectangle, sharp corners, minimum height=3ex, minimum width=3ex] (a) {};
				\node[draw, rectangle, sharp corners, minimum height=3ex, minimum width=3ex, above left=1ex and 2ex of a.west] (b) {};
				\node[draw, rectangle, sharp corners, minimum height=3ex, minimum width=3ex, below left=1ex and 2ex of a.west] (c) {};
				\node[draw, rectangle, sharp corners, minimum height=3ex, minimum width=3ex, above right=1ex and 2ex of a.east] (d) {};
				\node[draw, rectangle, sharp corners, minimum height=3ex, minimum width=3ex, below right=1ex and 2ex of a.east] (e) {};
				\node[above=3ex of a.north, align=center] (t) {\scriptsize Application Software\\[-1ex]\scriptsize writen in $L$};
				\draw (a) -- (b);
				\draw (a) -- (c);
				\draw (b) -- (c);
				\draw (a) -- (d);
				\draw (a) -- (e);
				\draw (d) -- (e);
			\end{tikzpicture}
		};
	 
	 \node[draw, rectangle, rounded corners, rectangle, align=center, below=1ex of c1.south] (c2) {\scriptsize Operational Semantics\\[-1ex]\scriptsize in $L$};
	 
	 \node[draw, rectangle, rounded corners, below right=0ex and 20ex of c1.north] (c3) {
			\begin{tikzpicture}
				\node[draw, rectangle, sharp corners, minimum height=3ex, minimum width=3ex] (a) {};
				\node[draw, rectangle, sharp corners, minimum height=3ex, minimum width=3ex, above left=1ex and 2ex of a.west] (b) {};
				\node[draw, rectangle, sharp corners, minimum height=3ex, minimum width=3ex, below left=1ex and 2ex of a.west] (c) {};
				\node[draw, rectangle, sharp corners, minimum height=3ex, minimum width=3ex, above right=1ex and 2ex of a.east] (d) {};
				\node[draw, rectangle, sharp corners, minimum height=3ex, minimum width=3ex, below right=1ex and 2ex of a.east] (e) {};
				\node[draw, rectangle, sharp corners, align=center, below=4ex of a] (f) {\scriptsize Execution Engine\\[-1ex]\scriptsize for $L$ in BIP};
				\node[above=3ex of a.north, align=center] (t) {\scriptsize Application Software\\[-1ex]\scriptsize writen in $L$};
				\draw (a) -- (b);
				\draw (a) -- (c);
				\draw (b) -- (c);
				\draw (a) -- (d);
				\draw (a) -- (e);
				\draw (d) -- (e);
				\draw (c.south) -- (c.south |- f.north);
				\draw (e.south) -- (e.south |- f.north);
				\draw (a) -- (f);
			\end{tikzpicture}
		};
		
		\coordinate[left=5ex of c3] (aux);
		\draw[thick] (c1.east) -- (aux);
		\draw[thick] (c2.east) -- (aux);
		\draw[->,thick] (aux) -- (c3);
	\end{tikzpicture}
	\caption{Overview of the method for generating BIP models for a language $L$.}
	\label{fig:method_embedding}
\end{figure}

This three step transformation from a language $L$ to BIP has been successfully applied for:
\begin{itemize}
	\item synchronous systems. We provide in \cite{BozgaSS09} a general representation for the synchronous programming model. 
		We show that we can meaningfully represent synchronous components e.g., Lustre nodes, using (compositions of) atomic components with a particular cyclic behavior. 
		This representation reveals in BIP the least coordination required for the correct execution of synchronous systems. 
		Moreover, for this particular class of components we provide sufficient syntactic conditions to ensure deadlock freedom and confluence of computations.
	\item MATLAB/Simulink. MATLAB/Simulink is a popular commercial tool for model-based design and simulation of dynamic embedded systems. 
		Simulink is widely used by engineers since it provides a wide variety of block libraries for implementing and testing discrete and continuous systems occurring in many application domains.
		We develop a method for the translation of a discrete-time fragment of Simulink into the synchronous subset of the BIP language. 
		The translation presented in \cite{SfyrlaTSBS10} is fully compositional, that is, it preserves the original structure and reveals the minimal control coordination structure 
		needed to perform the correct computation within Simulink models. Additionally, this translation can be seen as providing an alternative operational semantics of Simulink models using BIP.
	\item AADL. In \cite{ChkouriRBS08} we present a general methodology and an associated tool for the structural translation of AADL specifications into BIP. 
		In this work, we define precise operational models for all AADL components in terms of BIP components. Moreover, we clearly define the AADL communication mechanisms using various types of 
		ports in terms of BIP interaction models. This precise mapping enables simulation of systems specified in AADL as well as their analysis using formal verification techniques developed for BIP, 
		e.g. deadlock detection.
	\item GeNoM. GeNoM is a C++ software framework used for the implementation of the functional layer within autonomous robotic applications. In 
		\cite{BasuGLNBIS08,BensalemIS08} we show that BIP can be seamlessly integrated within the preexisting design methodology. More specifically,
		\begin{itemize}
			\item BIP has been used for (1) the incremental modeling of GenoM modules used to implement the functional level and (2) the modeling of their allowed interactions as specified 
				by the control execution level of the robot;
			\item The resulting BIP model has been used to synthesize a controller for the overall execution of all the functional modules and to enforce by construction the constraints 
				and the rules inside modules but also between the various functional modules;
			\item The BIP model has been also used to formally verify several safety-critical properties of the robot including ordering and synchronization constraints, data freshness properties, 
				deadlock-freedom, etc.
		\end{itemize}
	\item NesC/TinyOS. In \cite{BasuMPPS07} we present a compositional method for modeling and analyzing sensor network applications using BIP. 
		For every sensor, its model consists of a composition of (1) a model extracted from a nesC program describing the application, and (2) an abstract model of TinyOS components. 
		This opens the way for enhanced analysis and early error detection by using verification techniques.
	\item DOL. We define a rigorous method that allows obtaining a system model which faithfully represents the behavior of a mixed hardware/software system from a model of its application software, 
		a model of its underlying hardware architecture, and a given mapping. DOL is used as a front-end for describing the application software (in C), the hardware architecture (in XML), 
		and the mapping (in XML). We implement a tool that takes DOL description and generates a system model in BIP. The tool translates an application software implemented in C into BIP software model.
		The system model can be simulated and analyzed for the verification of both functional and extra-functional properties, using the BIP toolset, such as:
		\begin{itemize}
			\item Code generation for simulation/validation on a Linux PC.
			\item Functional correctness using the D-Finder tool, i.e., checking for deadlocks.
			\item Transformations for code generation that uses send/receive primitives for execution on distributed architectures.
			\item Performance analysis (e.g., latency), based on simulation and the statistical model checking tool integrated with BIP.
		\end{itemize}
\end{itemize}

The features described above, including a variety of verification tools, make from BIP a suitable framework for formalizing and validating TASTE designs.

\section{TASTE Modeling Concepts}
\label{sec:taste}

A TASTE design is made of several diagrams: {\em data view}, {\em interface view}, {\em deployment view} and {\em concurrency view}.

The {\em data view} allows modeling user-defined types in the ASN1 notation \cite{ASN}. These types are based on TASTE default types such as (unsigned) integers on 8 and 32 bits, reals 
and Booleans. The language allows defining sequences, arrays, enumerations, strings. For example  
  $$MyReal ::= \mathsf{REAL} (0.0 ... 1000.0) $$ 
  $$MyProd\ ::=\ \mathsf{SEQUENCE} (\mathsf{SIZE} (2))\ \mathsf{OF}\ MyReal$$ 
defines the type $MyProd$ as an array with 2 elements where each is of type $MyReal$. $MyReal$ defines all real values from 0 to 1000.

The {\em interface view} models the architecture of the system in terms of communicating software functions. A {\em software function} is the basic modeling element that defines the functionalities
performed by the system. Functions can be structured in {\em containers} based on their common features. For example, a container {\em Wheel} can define three functions: one modeling the nominal behavior, 
one modeling the faulty behavior and one modeling a life-cycle scenario. This notion is purely syntactical (and architectural), and has no implications on the execution of a system.

The new release of TASTE allows to define {\em hierarchical interface views}. In the following we consider only flat diagrams for formalization. That means that either the original diagram does not define 
hierarchical views or they have been flattened -- either manually or automatically. The next iteration of translation will consider the hierarchy aspect.

A function has several attributes such as {\em language}, {\em is\_Component\_Type}, {\em is\_instance\_of}. The {\em language} attribute specifies which programming/modeling language 
is used to describe its functionalities. Among the possible options we find Ada, C, SDL, Simulink, Scade, etc. We are interested here mainly in the SDL notation of functions. The other two attributes 
are related to defining function types for multiple instantiations. These two attributes are not considered here.

A function can also define parameters which its behavior can access. These parameters are either of predefined types, user-defined types or {\em Timer} to model timed behavior.

The functionalities of a function are available to its environment via {\em provided interfaces}. A provided interface is in fact an interaction point which allows for 
function calls in programming languages or sending signals in modeling languages (like SDL). Based on the reception of the request (either call or signal), the function executes the functionality 
associated to the request. Requests can be made by other functions through {\em required interfaces} connected by wires with provided interfaces. The direction is a always from 
a required interface to a provided one.

\begin{wfr}
  Within a software function, the names of its parameters and provided interfaces are unique.
\end{wfr}

\begin{wfr}
  Every function defines at least one provided interface.
\end{wfr}

\begin{wfr}
  In a flat interface view, a provided interface can be connected to one or several required interfaces. All other combinations (e.g., required - provided - provided) are forbidden.
\end{wfr}

A provided interface can define parameters. These parameters have two {\em directions}: {\em in} for input parameters and {\em out} for result parameters. These parameters 
are of any the types defined above. Based on the type of the provided interface, restrictions can be applied to the parameters that they can define.

Indeed, there are 4 types of provided interfaces:
\begin{itemize}
 \item {\em cyclic}. Their aim is to activate the function's execution periodically, as specified by the designer. Therefore, cyclic provided interfaces do not define 
 parameters. They however have the following attributes: {\em period}, {\em deadline}, and {\em worst-case execution time} (wcet). The period specifies with what frequency 
 the function's behavior is executed. The deadline and wcet are additional information for the scheduling analysis, i.e., before what time the function should execute 
 and how long its execution will last. 
 \item {\em sporadic}. These interfaces model asynchronous communication between functions. In consequence, a sporadic interface can define only one parameter of 
 in direction. If several parameters need to be transferred then they can be wrapped in an ASN1 datatype as shown above. This interface defines the attributes: 
 {\em minimimal inter-arrival time} (miat), deadline, worst-case execution time, and {\em queue size}. The miat is similar to be period of cyclic interfaces and models how often 
 the service can be provided. The {\em queue size} is needed to model asynchronous communication and defines how many requests can be stored by the interface before being while 
 waiting to be handled. Similarly as above, the deadline and wcet are needed for scheduling analysis.
 \item {\em protected}. These interfaces model synchronous communications between functions, where parameters can be sent in both directions. Moreover these interface have 
 a protected access to the functions parameters. Once a call is made the execution of the interface runs to completion before another call can be handled. This interface 
 defines the scheduling attributes deadline and wcet.
 \item {\em unprotected}. These interfaces also model synchronous communications, but for each interface call a new job is created. Therefore, several jobs (instances of 
 interface execution) can be performed in parallel and change the function's parameters in an unexpected manner. This interface defines the scheduling attributes deadline and wcet.
\end{itemize}

\begin{wfr}
  A cyclic provided interface does not define any parameter. 
\end{wfr}

\begin{wfr}
  A sporadic provided interface defines only one in parameter.
\end{wfr}

\begin{wfr}
  A function in SDL notation can have only cyclic and sporadic provided interfaces.
\end{wfr}

\begin{wfr}
  For a TASTE design in SDL notation, all provided interfaces of a function which can be either cyclic or sporadic are mutually exclusive and execute in run-to-completion.
\end{wfr}

\begin{wfr}
  For a TASTE design in SDL notation, the sporadic provided interfaces execute in run-to-completion and their caller does not wait for the completion, i.e., fire and forget. 
\end{wfr}


Finally, an interface view is given by a network of communication functions through interfaces. We impose the following restrictions on the top-level interface view.

\begin{wfr}
  In an interface view at least one function defines one cyclic provided interface.
\end{wfr}

This rule is needed in order to start the execution of a system. The cyclic interface clearly defines when the system's execution should trigger. In contrast, 
a sporadic interface gives some bounds of when the function's behavior is executed and this is selected by the scheduler. However, when simulating in TASTE a model that has 
as trigger a sporadic interface, no behavior can be observed. In consequence, we request that the top-level interface view defines a cyclic provided interface.

\begin{wfr}
  In an interface view, all sporadic provided interfaces are connected to a required interface.
\end{wfr}

This rule ensures the consistency of the previous one with respect to triggering observable (by simulation) behavior.

As mentioned above, software function behavior can be expressed in either programming or modeling languages, from which we focus on SDL. SDL is a graphical notation that describes 
the function's behavior as state machines. A state machine is mainly defined by a set of locations and transitions between locations. A transition in SDL has the following pattern: 
\textsf{trigger; (condition $\vert$ action)*}. A transition has a run-to-completion execution, only the defined locations being ``accessible'' to the other functions.

A trigger can be the reception of an signal via a provided interface, a continuous signal or a timeout event. A continuous signal is defined as a 
predicate over the function's variables and, when evaluated to \textsf{true}, the corresponding transition is executed. A timeout event occurs when the previously set Timer variable 
has the value 0.

A condition is generally a (set of) predicate(s) on the function's parameters. 
It can have multiple branches and only one can be evaluated to true at a moment. That branch is consequently fired during the execution. 
The actions to be performed on a transition are:
tasks (i.e., assignments), sending signals and calling procedures. 

An SDL state machine can define parameters (similar to the function parameters including Timers) and 
procedures with in/out arguments, which are also modeled as state machines. A few predefined procedures exists, such as \text{writeln}, \textsf{set\_timer} and \textsf{reset\_timer}.

The {\em deployment view} defines how the software functions are mapped to hardware. Therefore, it models the underlying hardware architecture of the system in terms of processors, 
buses, drives, etc. Each software function is then associated with a hardware element and the communication between them is possibly associated to buses.

The {\em concurrency view} provides a complete view of the system, incorporating both the software and hardware architecture. It is automatically generated from the interface view 
and the deployment view and can be analyzed for scheduling feasibility by different tools.


\section{A Flavour of Timed Automata}

% maybe add some notation especially with respect to the semantics

\subsection{Abstract Syntax}
\label{subsec:syntax}

Let $V$ be a set of {\em variables} $x$, $y$, $\ldots$. Each variable $v$ has a type $T_v$ ($v : T_v$), and we denote its range by $\Sigma_v$. The range is implicitly defined by the type of the variable.
Let $\Sigma_V = \bigcup_{v \in V} \Sigma_v$. %\limits
A function $val : V \rightarrow \Sigma_V$ is the valuation of the variables $v \in V$ such that $val(v) \in \Sigma_v$. All the first-order expressions on variables from $V$ are denoted by $Exp(V)$.

A variable $v$ can be part of a {\em constraint} $g$, a first order predicate (without quantifiers). Formally, $g : \Sigma_V \rightarrow \mathsf{Bool}$. We denote a set of constraints over $V$ by $\Phi(V)$.
These constraints will be used hereafter to denote transition guards. 

A special type of variables that we consider here separately are the {\em clocks}. Clocks model real time elapse in a design and their value is given by a function $val : Clk \rightarrow \mathbb{R}$, where 
$Clk$ is a set of clocks. Therefore, they can be set a certain value and reset. 
Constraints on clocks are provided by the following grammar:
$$\varphi ::= x \leq c\ \vert\ c \leq x\ \vert\ x - y  \leq c\ \vert\ \neg \varphi\ \vert\ \varphi_1 \land \varphi_2 $$ 
where $x$ and $y$ are clocks and $c \in \mathbb{Q}$ is a constant. We denote the set of clocks a model defines by $Clk$ and a set of contraints on $Clk$ by $\Phi(Clk)$. These constraints will be used 
to model guards and location invariants in a component's behavior

We define the interaction points between components as {\em ports}. A port is mainly given by the name of operation it represents and its arguments. 

\begin{definition}[Port]
  A {\em port} $p$ is a tuple $(name, direction, args)$ where $name$ is the operation label, $direction \in \{in, out, return\}$ gives the directionality of requests, and $args \subseteq V$ a list of operation arguments. 
  Syntactically, we denote a port $p$ by $name\_direction(args)$.
\end{definition}

The actions that describe the system's functionalities can be generated by the following grammar.

\begin{definition}[Action]
  An action $a$ over a set of variables $V$, a set of clocks $Clk$ and a set of ports $P_V$ is:
  \begin{eqnarray*}
    \begin{aligned}
      a ::=\  & \text{(assignment)}         & v := e,                    &~ v \in V,\ e \in Exp(V)                        & \vert \\ 
              & \text{(sending signal)}     & sig\_out(v),               &~ sig\_out \in P_V,\ v \in V \cup Clk           & \vert \\
              & \text{(receiving signal)}   & sig\_in(v),                &~ sig\_in \in P_V,\ v \in V \cup Clk            & \vert \\
              & \text{(completion signal)}  & sig\_return(),             &~ sig\_return \in P_V                           & \vert \\ 
              & \text{(timer set)}          & \mathsf{set\_timer}(e, t), &~ t \in Clk,\ e \in Exp(V) (\in \mathbb{R}) & \vert \\
              & \text{(timer reset)}        & \mathsf{reset\_timer}(t),  &~ t \in Clk
    \end{aligned}
  \end{eqnarray*}
\end{definition}

The behavior of a function is defined by a timed automaton extended with data and urgencies.

\begin{definition}[Behavior]
\label{def:ta}
  A behavior $B$ over a set of variables $V$, of clocks $Clk$ and of ports $P_V$, denoted $B_{V, Clk, P_V}$, is the tuple $(L, l_0, Exp(V), \Phi(V), \Phi(Clk), I, A, U, T)$ where:
  \begin{itemize}
   \item $L$ is a set of {\em locations},
   \item $l_0$ is the initial location,
   \item $Exp(V)$ is a set of first-order expressions on $V$,
   \item $\Phi(V)$ is a set of constraints on $V$,
   \item $\Phi(Clk)$ is a set of constraints on $Clk$,
   \item $I : L \rightarrow \Phi(Clk)$ is a function that associates to each location some clock constraint called {\em invariant}, 
   \item $A$ is a set of actions on $V$, $Clk$ and $P_V$, 
   \item $U = \{\mathsf{lazy}, \mathsf{eager}\}$ is the urgency labels,
   \item $T \subseteq L \times \big(\Phi(V) \cup \Phi(Clk)\big) \times A \times U \times L$ is a set of {\em transitions} of the form $(l, g, a, u, l')$, 
    also written as $\trs{l}{l'}{g}{a}{u}$. $g$ is the {\em guard} and controls when a transition can be fired. Equally, $u$ sets the urgency with which the 
    transition should be fired. $a$ is the action to be executed when firing the transition. $l$ and $l'$ are the source and target locations respectively.
  \end{itemize}
\end{definition}
%A transition can be fired if the guard evaluates to true and the urgency condition is equally satisfied.


The difference between \cite{AlurD94} and Def.~\ref{def:ta} is that \cite{AlurD94} uses only clocks to model a system's behavior, while we accept other types of variables (e.g., Boolean,
integer, enumeration, arrays, etc.). Also Def.~\ref{def:ta} uses urgencies in addition to invariants to model when actions must be executed. Urgencies have 2 possible values (labels): 
{\em eager} (also denoted by $\epsilon$) models that the transition must be fired as soon as it is enabled and time elapse is disabled; {\em lazy} (also denoted by $\lambda$) specifies that 
time elapse is enabled and the execution can choose between letting time progress or executing the enabled transition. In \cite{DBLP:journals/iandc/BornotS00} a third label is accepted: 
{\em delayable} specifies that time can elapse in a state where a transition is enabled up to a limit where the transition becomes eager. However a delayable transition can be expressed 
with the eager and lazy urgencies and therefore we do not consider it here. In a state, time can elapse as long as the invariant and the conjunction of urgencies is satisfied.

A component is modeled by variables, clocks, ports and behavior.

\begin{definition}[Component]
\label{def:comp}
  A component $C$ is the tuple $(V, Clk, P_V, B_{V, Clk, P_V})$ where $V$ and $Clk$ are a set of variables and clocks respectively, $P_V$ a set of ports on $V$ and $B_{V, Clk, P_V}$ 
  is the component's behavior described as above.
\end{definition}

Finally, a system is given by a set of components where the interaction is based on {\em port matching}: two transitions which carry the same port action will synchronize. This aspect will be made clear in 
\S\ref{subsec:semantics} and \S\ref{subsec:translation_iv}.


\subsection{Semantics}
\label{subsec:semantics}

In the following we define the semantics of our components.

\begin{definition}[Component configuration]
  Semantically, a component $C$ is represented by the tuple $K = (s, val)$ where:
  \begin{itemize}
   \item $s \in Loc$, and
   \item $val$  is the valuation function for the variables and clocks the component defines, i.e., $val : V \rightarrow \Sigma_V$ and $val : Clk \rightarrow \mathbb{R}$.
  \end{itemize}
\end{definition}
A special type of variable can be considered the queue. Due to the modeling elements of TASTE, not all components define a queue. In fact this element can be observed only for the sporadic provided interfaces.
In consequence, we will model the queue handling explicitly as shown in \S\ref{sec:translation_iv}. The queue is part of the set $V$ of variables, and its elements $q \in {\Sigma^{*}_V}$ correspond to the arguments 
of the received requests.

\begin{definition}[System configuration]
  A system configuration is $S = \{K_1, K_2, \ldots, K_n\}$ where $n$ is the number of components the system contains. 
\end{definition}

Finally we define the execution of the system based on each action it can perform:
\begin{definition}[System actions] ~
  \begin{enumerate}
   \item Variable assignment:
    \[
      \inference{\trs{l}{l'}{g}{v:=e}{u} & K.s=l & K.val \models I(l) & K.val \models g &\\ 
		    e \in Exp(V) & K.val(e) = d & d \in \Sigma_V & K.val[v \leftarrow d] \models I(l')}
		{\trs{K}{K\left[\begin{array}{c} s=l'\\ val=val[v \leftarrow d]\end{array}\right]}{}{\tau}{u}}
    \]
   \item Queue append:
    \[
      \inference{\trs{l}{l'}{g}{q.\mathsf{append}(args)}{u} & K.s=l & K.val \models I(l) & K.val \models g &\\ 
		  args \in \Sigma^{*}_{V} & K.val[q \leftarrow q \oplus args] \models I(l')}
		{\trs{K}{K\left[\begin{array}{c} s=l'\\ val=val[q \leftarrow q \oplus args]\end{array}\right]}{}{\tau}{u}}
    \]   
   \item Queue pop:
    \[
      \inference{\trs{l}{l'}{g}{q.\mathsf{pop}()}{u} & K.s=l & K.val \models I(l) & K.val \models g &\\ 
		    val(q) = args \oplus val(q') & K.val[q \leftarrow q'] \models I(l')}
		{\trs{K}{K\left[\begin{array}{c} s=l'\\ val=val[q \leftarrow q']\end{array}\right]}{}{\tau}{u}}
    \]    
   \item Timer set:
    \[
      \inference{\trs{l}{l'}{g}{\mathsf{set\_timer}(e, t)}{u} & K.s=l & K.val \models I(l) & K.val \models g &\\ 
		  t \in Clk & e \in Exp(V) & val(e) = c \in \mathbb{Q} & K.val[t \leftarrow (-c)] \models I(l')}
		{\trs{K}{K\left[\begin{array}{c} s=l'\\ val=val[t \leftarrow (-c)]\end{array}\right]}{}{\tau}{u}}
    \] 
   \item Timer reset:
    \[
      \inference{\trs{l}{l'}{g}{\mathsf{reset\_timer}(t)}{u} & K.s=l & K.val \models I(l) & K.val \models g &\\ 
		  t \in Clk & K.val[v \leftarrow 0] \models I(l')}
		{\trs{K}{K\left[\begin{array}{c} s=l'\\ val=val[t \leftarrow 0]\end{array}\right]}{}{\tau}{u}}
    \]    
   \item Signal sending, reception and completion ($sig$):
    \[
      \inference{\trs{l_1}{l'_1}{g_1}{sig(args)}{u} & \trs{l_2}{l'_2}{g_2}{sig(args)}{u} \\ &
		 K_1.s=l_1 \qquad  K_1.val \models I(l_1) \qquad & K_2.s=l_2 \qquad K_2.val \models I(l_2) \\ &
		 K_1.val \models g_1 \qquad K_1.val \models I(l'_1) \qquad \qquad & K_2.val \models g_2 \qquad \qquad \\ &
		 K_1.val(args) = d \qquad \qquad \quad & K_2.val[args \leftarrow d] \models I(l'_2) 
		}
		{\trs{\{K_1, K_2\}}{\{K_1\left[s=l'_1\right], K_2\left[\begin{array}{c} s=l'_2 \\ val=val[args \leftarrow d]\end{array}\right]\}}{}{sig(args)}{u}}
    \]    
   \item Time progress:
      \begin{itemize}
       \item component time lapse
	\[
	  \inference{\delta \in \mathbb{R}_{+}}{\trs{K}{K\left[val = val[\forall t \in Clk, t \leftarrow t + \delta] \right]}{}{\delta}{}}
	\]

       \item all components advance at the same time 
	\[
	  \inference{\trs{K_1}{K'_1}{}{\delta}{} & \ldots & \trs{K_n}{K'_n}{}{\delta}{} & \delta \in \mathbb{R}_{+}}
		    {\trs{\{K_1, \ldots, K_n\}}{\{K'_1, \ldots K'_n\} }{}{\delta}{}}
	\]
       \item maximal time lapse  -- an {\em eager} transition has higher prority than the others 
	\[
	  \inference{ \delta \in \mathbb{R}_{+} & \{ \trs{S''}{S'''}{}{a}{eager}\ \vert\ \exists \delta' \in [0, \delta). \trs{S}{S''}{}{\delta'}{} \} = \emptyset}
		    {\trs{S}{S'}{}{\delta}{}}
	\]    
       \item time additivity
	\[
	  \inference{\trs{S}{S'}{}{\delta_1}{} & \trs{S'}{S''}{}{\delta_2}{}}
		    {\trs{S}{S''}{}{\delta_1 + \delta_2}{}}
	\]
      \end{itemize}
  \end{enumerate}
\end{definition}


\section{Formalizing TASTE Designs to Timed Automata}

%\subsection{Data View}
%\label{subsec:translation_dv}

The following formalization concerns the system structure and its behavior, regardless of the data type used. The instantiation of this formalization within the BIP language is described in \S\ref{sec:patterns},
for both data and interface views.

\subsection{Interface View}
\label{subsec:translation_iv}

Each software function defined in a design becomes a component.

\begin{tr}
  A function $F$ becomes a component $C = (V, Clk, P_V, B_{V, Clk, P_V})$ where:
  \begin{itemize}
   \item $V$ is given by the function's properties except those typed $Timer$.
   \item $Clk$ is given by only the function's properties typed $Timer$,
   \item $P_V$ is given by the provided and required interfaces where each becomes a port over the corresponding variables $v \subseteq V$, and
   \item $B_{V, Clk, P_V}$ is the timed automaton extended with data obtained as described in \S\ref{sec:translation_sdl}.
  \end{itemize}
\end{tr}

In order to faithfully model the behavior of TASTE SDL machines, we make the corresponding timed automata input-complete. 
Let $states$ be a function that for an SDL state machine returns the set of states it defines. 

\begin{tr}
  For a function $F$ described by a state machine $SM$ we have that 
  $$\forall sig\_in \in P_V,\ \forall s \in Loc \cap states(SM),\ \exists \trs{s}{l}{g}{sig\_in}{u}$$
  where $l$ is  either $s$ or a new location.
\end{tr}

The provided interface of a function becomes a component, where its variables and behavior is dependent on its type.

\begin{tr}
  A {\em cyclic} provided interface $I$ is a component $C = (V, Clk, P_V, B_{V, Clk, P_V})$ where:
  \begin{itemize}
   \item $V = \emptyset$,
   \item $Clk = \{t\}$,
   \item $P_V = \{sig\_out(), sig\_return()\}$,
   \item $B_{V, Clk, P_V}$ is the automaton illustrated in Fig.~\ref{fig:cyclic_pi}. In this automaton the parameter $period$ is explitictly stated by its value, and therefore there is no need to represent it
    with a variable.
  \end{itemize}
\end{tr}

\begin{figure}[h]
  \centering
  \scalebox{0.7}{
  \begin{tikzpicture}[->,>=stealth',shorten >=1pt,auto,node distance=3.8cm,semithick]
  \node[initial,state,circle split] (l0)               {$l_0$ \nodepart{lower} \textcolor{white}{$t \leq \mathsf{period}$}};
  \node[state,circle split]         (l1) [right= 20ex of l0] {$l_1$ \nodepart{lower} $t \leq \mathsf{deadline}$};
  \node[state,circle split]         (l2) [below of=l1] {$l_2$ \nodepart{lower} $t \leq \mathsf{period}$};

    
  \path (l0) edge             node[align=center] {${sig\_out}\ /$\\$reset\_timer(t)^{\epsilon}$}    (l1)
        (l1) edge [bend right,left] node {${sig\_return}^{\epsilon}$} (l2)
        (l2) edge [bend right,right] node[align=right] {$[t = period]$ $/$ \\ ${sig\_out};$ \\ $reset\_timer(t)^{\epsilon}$}(l1);   
  \end{tikzpicture}}
  \caption{Timed automaton corresponding to the behavior of a cyclic provided interface.}
  \label{fig:cyclic_pi}
\end{figure}

\begin{tr}
  A {\em sporadic} provided interface $I$ is a component $C = (V, Clk, P_V, B_{V, Clk, P_V})$ where:
  \begin{itemize}
   \item $V = \{args, q\}$ with $q \in \Sigma_{args}$ the component's queue,
   \item $Clk = \{t\}$,
   \item $P_V = \{sig\_out(args), sig\_in(args), sig\_return()\}$ with $sig\_out$ modeling the output of the component requesting the service and $sig\_in$ modeling the input of the component providing the service,
   \item $B_{V, Clk, P_V}$ is the automaton illustrated in Fig.~\ref{fig:sporadic_pi}
  \end{itemize}
\end{tr}


\begin{figure}[!h]
  \centering
  \scalebox{0.7}{
  \begin{tikzpicture}[->,>=stealth',shorten >=1pt,auto,node distance=2.8cm,semithick]
    \node[initial,state,circle split] (l0)               {$l_0$ \nodepart{lower} \textcolor{white}{$t \leq miat$}};
    \node[state,circle split]         (l1) [below of=l0] {$l_1$ \nodepart{lower} $t \leq deadline$};
    \node[state,circle split]         (l2) [below of=l1] {$l_2$ \nodepart{lower} $t \leq miat$};
    
    \path (l0) edge [loop above] node {$[length(q) < size] / (sig\_out(args); q.append(args))^{\epsilon}$} (l0)
	  (l0) edge [loop right] node {$[length(q) > size] / sig\_out(args)^{\epsilon}$} (l0)
	  (l0) edge [bend left] node {$[length(q) > 0] / (args := q.pop(); sig\_in(args); set\_timer(0,t))^{\epsilon}$} (l1)
	  (l1) edge [bend left] node {$sig\_return^{\epsilon}$} (l2)
	  (l1) edge [loop right,in=20,out=40,min distance=10mm] node {$[length(q) < size] / (sig\_out(args); q.append(args))^{\epsilon}$} (l1)
	  (l1) edge [loop right,in=340,out=360,min distance=10mm] node {$[length(q) > size] / sig\_out(args)^{\epsilon}$} (l1)
	  (l2) edge [bend left=60] node {$[t = miat] / (reset\_timer(t))^{\epsilon}$} (l0)
	  (l2) edge [loop below] node {$[length(q) < size] / (sig\_out(args); q.append(args))^{\epsilon}$} (l2)
	  (l2) edge [loop right] node {$[length(q) > size] / sig\_out(args)^{\epsilon}$} (l2);
  \end{tikzpicture}}
  \caption{Timed automaton corresponding to the behavior of a sporadic provided interface.}
  \label{fig:sporadic_pi}
\end{figure}

\subsection{SDL State Machines}
\label{subsec:translation_sdl}

The following transformation rules apply for SDL machines modeled in TASTE/OpenGEODE. Basically, each element of the state machine is transformed into an 
element of the timed automaton of the corresponding component.

\begin{tr}~
  \begin{enumerate}
    \item A state $s$ becomes a location $s \in Loc$.
    \item An input from the interface named $sig$ and with arguments $args$ becomes the action $sig\_in(args)$.
    \item An input from a $Timer$ $t$ becomes the guard $[t=0]$.
    \item A continuous signal with condition $c$ becomes a guard $[c]$.
    \item A task becomes an assignment action corresponding to the expressions contained.
    \item A decision is partially becoming a guard. Its expression is parsed and stored and used in conjunction with the decision answer. 
      Then a decision $e$ and a decision answer $a$ becomes a guard $[e=a]$. The other decision answers are translated accordingly.
    \item An output to the interface named $sig$ and with arguments $args$ becomes the action $sig\_out(args)$, where $args$ are transferred by value.
    \item A procedure call $m$ is translated based on its content: (i) if it is a locally defined procedure, then its definition is expanded here (?) and translated 
      according to the rules defined above, (ii) if it is a protected/unprotected interface call then it becomes an output action followed by an input one 
      with possibly the return value, (iii) if it is a predefined procedure (e.g., $set\_timer$, etc.), then it is translated as an action of the same type. For now, 
      we are limiting the calls to cases (i) and (iii).
    \item A DCL declaration populates the set of variables defined by the component owing the state machine.
  \end{enumerate}
\end{tr}

As mentioned in \S\ref{sec:taste}, an SDL transition is of the form $\mathsf{trigger}; (\mathsf{condition} \vert \mathsf{action})^{*}$, where the $\mathsf{trigger}$ is 
either an input, a continuous signal or a $Timer$ reaching value $0$; the $\mathsf{condition}$ is a decision with answers and the $\mathsf{action}$ is a task, an output 
or a procedure call. Every SDL transition has one trigger and several conditions and actions. Because our syntax allows to model only one action per transition we have 
to generate auxiliary intermediate locations.

\begin{tr}
  An SDL transition $\trs{s}{s'}{}{\mathsf{trigger}; \mathsf{action}_1; \mathsf{action}_2; \ldots \mathsf{action}_n}{}$, $\forall n \in \mathbb{N}$ becomes a chain of timed automata transitions 
  $ s \xrightarrow[eager]{trigger} l_1 \xrightarrow[eager]{action_1} l_2  \xrightarrow[eager]{action_2} \ldots \xrightarrow[eager]{action_n} s'$, with $s, s', l_1, \ldots, l_n \in Loc$, and 
  $trigger$, $action_i$ are the corresponding timed automata counterpart action of $\mathsf{trigger}$, $\mathsf{action}_i$.
\end{tr}




\section{BIP Patterns for the (Formal) TASTE Modeling Elements}
\label{sec:patterns}

\subsection{The BIP Notation}
\label{subsec:bip}

BIP is a textual formal language based on Timed Petri Nets (TPA) that allows the modeling of embedded systems. For the current translation we consider the semantics to be given as timed automata (TA) [11] which is a subset of TPA.
Mainly a BIP model can be seen as a network of communicating components represented as timed automata extended with data. There are several differences with respect to the definition from [11]: (1) components can define typed variables, (2) components are typed which facilitates their definition and multiple instantiation, (3) components can be involved in complex interactions than the classical action matching, and (4) orders of execution can be specified by means of priorities and urgencies.
The definition of a BIP model follows the structure: definition of component types, definition of component interaction types, instantiation of the system – component and interaction -, and definition of priorities. We describe next each of the modeling elements.
A component can be either atomic or compound. An atomic component is described by a state machine i.e., timed automaton. A compound component is described by the instances it contains. 
An atomic component can define local typed variables, including clocks. Its computations are represented by a state machine: control locations connected by transitions and on which operations are performed. the maximal time lapse in a state can be modeled with an invariant The locations are enumerated with the keyword place. The maximal time lapse in a control location can be modeled with an invariant. A transition is given by: 
on action
  from loci to locj
  [provided (guard)]
  [eager | delayable | lazy]
  [do { (assignment; | conditional; | function\_call;)+ }]  
The transition starts by defining the action to be performed, which is either an interaction with other components or a local event. Then we mention the source and target locations of the transition. The transition can be enabled only under some constraints defined by a guard. A guard is a conjunction/disjunction of predicates on data variables and clocks. Next we describe the urgency of the transition: eager means that a transition must be fired as soon as it is enabled, delayable means that the firing of an enabled transition can be delayed up to an upper bound, and lazy means that a transition can be fired at any moment or never. Finally, different instructions can be performed on a transition such as variable/clock assignments with complex expressions, and function calls possibly imbricated in conditionals (e.g., if conditional). The guard, urgency and instructions are not mandatory, but at most one can be present.
The actions a component is involved in are defined by ports. A port can define typed parameters involved in interactions and computations. Ports that are involved in interactions are defined as exported, while the others are standard local ports. Ports are also typed: port types are defined in the model and a component instantiates port types by giving them a name and specifying which of its local data is affected by that port.
Interactions between components are defined as connectors. For a model we can define different connector types corresponding to the interactions needed, which are then instantiated when defining compound component types. A connector can define complex interactions, e.g., whether all components need to synchronize or only a subset and which are the possible subsets. Moreover connectors can define local variables and computations on local and port variables.
Finally, compound component types such as the system are described by the instances of owned ports, components and connectors. Connectors can link the ports of the different components, but they can also involve ports of the compound. Therefore, we can express in BIP hierarchical, open systems.
The order of execution of enabled interactions can be constrained with priorities. One can specify between two given interactions which has the higher priority and in which cases the rule applies. The priority mechanism is internal to a compound.

We present now the BIP \cite{BasuBS06} patterns that correspond to a TASTE model formalized as network of timed automata. 
BIP is a textual language that allows describing stochastic/timed systems and 
which is equipped with several engines for stochastic, real-time or stepwise simulations, a tool for compositional invariant-based verification and statistical model-checking. 
The expressivity of BIP is sufficient to represent timed automata TASTE models. The provided patterns in BIP are quite straightforward, the main difference concern the definition of type automata 
and their instantiation. Minor syntax differences can also be found with respect to the above definitions. We consider in the following \texttt{sig} to be a generic unique name to define the signals 
of a cyclic/sporadic provided interface within a pattern. 

\subsection{System Definition}

For a TASTE design three files are generated ...

%We iterate over the parameters sent on a signal with \texttt{ParamName}\textit{i} for the name and \texttt{ParamType}\textit{i} for the corresponding type.

%--------------
%model

\begin{pt}
  A TASTE model will be generated in the file \texttt{TasteModel.bip} which contains by default the BIP model definition:
  \mathligsoff
  \begin{lstlisting}[frame=single]
@cpp(src="ext-cpp/TasteModel.cpp",include="TasteModel.hpp")
package TasteModel
  ...
end \end{lstlisting} \mathligson

  Data types and external operations are defined in the \texttt{ext-cpp/TasteModel.hpp} which by default contains:
  \begin{lstlisting}[frame=single]
#ifndef _TASTE_MODEL_HPP_
#define _TASTE_MODEL_HPP_

#include<iostream>
#include<queue>
...
#endif 
  \end{lstlisting} 
  and the associated code in the \texttt{ext-cpp/TasteModel.cpp} which by default contains:
  \begin{lstlisting}[frame=single]
#include "TasteModel.hpp" 
... 
  \end{lstlisting}
\end{pt}



\subsection{Data View Patterns}
\label{subsec:patterns_dv}

``flattened'' data types to basic types (for those with intermediate elements

these are basic patterns, other functions can be added

\subsubsection{Enumerated}

An \textit{enumeration} $E$ is defined by the list of all possible values:
\begin{lstlisting}[frame=single,mathescape]
E ::= ENUMERATED
{
  val1,
  val2,
  $\cdots$,
  valn
} \end{lstlisting}

\begin{pt}
  Let $val_i$ index over the elements of the enumeration $E$.
  
  For the enumeration $E$ generate the following signatures in \texttt{ext-cpp/TasteModel.hpp}
  \begin{lstlisting}[frame=single,mathescape]
const asn1Scc$E$ get_$val_i$();
ostream &operator<<(ostream &os, const asn1Scc$E$ &v);
  \end{lstlisting}
  and in \texttt{ext-cpp/TasteModel.cpp} the implementation
  \begin{lstlisting}[frame=single,mathescape]
const asn1Scc$E$ get_$val_i$() {
  return asn1Sccvali;
}

ostream &operator<<(ostream &os, const asn1Scc$E$ &v){
  if (v == get_$val_i$()) os<<"$val_i$";
  return os;
}\end{lstlisting}  

  In the BIP model \texttt{TasteModel.bip} generate the following template in the external code part, where $val_i$ indexes over the elements of the enumeration:
  \begin{lstlisting}[frame=single,mathescape]
extern data type asn1Scc$E$
extern function const asn1Scc$E$ get_$val_i$()
extern operator bool == (const asn1Scc$E$, const asn1Scc$E$)
\end{lstlisting}    
\end{pt}

\subsubsection{Sequence}

A \textit{sequence} $S$ is defined by a set of typed variables, where two or more variables can have the same type.
\begin{lstlisting}[frame=single,mathescape]
S ::= SEQUENCE
{
  var1 type1,
  var2 type2,
  $\cdots$,
  varn typen
} \end{lstlisting}

\begin{pt}
  Let $var_i$ index over the variables defined by the structure and $type_i$ its corresponding type.
  
  For the sequence structure $S$ generate the following signatures in \texttt{ext-cpp/TasteModel.hpp}
  \begin{lstlisting}[frame=single,mathescape]
const asn1Scc$type_i$ get_$var_i$(const asn1Scc$S$ &v);
void set_$var_i$(asn1Scc$S$ &v, const asn1Scc$type_i$ &val);
ostream &operator<<(ostream &os, const asn1Scc$S$ &v);
  \end{lstlisting}
  and in \texttt{ext-cpp/TasteModel.cpp} the implementation
  \begin{lstlisting}[frame=single,mathescape]
const asn1Scc$type_i$ get_$var_i$(const asn1Scc$S$ &v){
  return v.$var_i$;
}

void set_$var_i$(asn1Scc$S$ &v, const asn1Scc$type_i$ &val){
  v.$var_i$=val;
}

ostream &operator<<(ostream &os, const asn1Scc$S$ &v){
  os<<v.var1<<" "<<v.var2<<" "<<$\cdots$<<v.varn;
  return os;
}
  \end{lstlisting}

  In the BIP model \texttt{TasteModel.bip} generate the following template in the external code part:
  \begin{lstlisting}[frame=single,mathescape]
extern data type asn1Scc$S$
extern function const asn1Scc$type_i$ get_$var_i$(const asn1Scc$S$)
extern function set_$var_i$(asn1Scc$S$, const asn1Scc$type_i$)
extern operator bool == (const asn1Scc$S$, const asn1Scc$S$)
\end{lstlisting}    
\end{pt}

\subsubsection{Sequence of}

A \textit{sequence of} $S$ is defined by a typed array.
\begin{lstlisting}[frame=single,mathescape]
S ::= SEQUENCE (size) OF type
\end{lstlisting}

\begin{pt}
  Let $size$ be the maximal size defined for the sequence of $S$, $var_i$ index over the variables defined by the structure and $type_i$ its corresponding type.
  
 In \texttt{ext-cpp/TasteModel.hpp} generate the following signatures:
  \begin{lstlisting}[frame=single,mathescape]
const asn1Scctype get_elem(const asn1Scc$S$ &v, const int &pos);
void set_elem(asn1Scc$S$ &v, const asn1Scctype &val, const int &pos);
ostream &operator<<(ostream &os, const asn1Scctype &v);
  \end{lstlisting}
  and in \texttt{ext-cpp/TasteModel.cpp} the implementation
  \begin{lstlisting}[frame=single,mathescape]
const asn1Scc$type$ get_elem(const asn1Scc$S$ &v, const int &pos){
  if (pos<size)
    return v.arr[pos];
  return NULL;
}

void set_elem(asn1Scc$S$ &v, const asn1Scc$type$ &val, const int &pos){
  if (pos<size)
    v.arr[pos]=val;
}

ostream &operator<<(ostream &os, const asn1Scc$type$ &v){
  for(int i=0; i<size; i++)
    os<<v.arr[i]<<" ";
  return os;
}
  \end{lstlisting}

  In the BIP model \texttt{TasteModel.bip} generate the following template in the external code part:
  \begin{lstlisting}[frame=single,mathescape]
extern data type asn1Scc$S$
extern function const asn1Scc$type$ get_elem(const asn1Scc$S$, const int)
extern function set_elem(asn1Scc$S$, const asn1Scc$type$, const int)
extern operator bool == (const asn1Scc$S$, const asn1Scc$S$)
\end{lstlisting}    
\end{pt}


\subsection{Interface View Patterns}
\label{subsec:patterns_iv}

For the moment, the below patterns instantiate correctly when only one parameter of a predefined basic type (i.e., no ASN structured types) is sent with signals.

%--------------
%external data types


\begin{pt}
  For every sporadic provided interface with parameters generate the following signatures:
  \begin{lstlisting}[frame=single]
   extern data type queueParamType
   extern function int get_size(const queueParamType)
   extern function push_back(queueParamType, ParamType, int)
   extern function ParamType pop_front(queueParamType)
  \end{lstlisting}
Additionally the following C++ code is generated in the \texttt{ext-cpp/TasteModel.hpp}:
  \begin{lstlisting}[frame=single]
typedef std::queue<ParamType> queueParamTypes;

int get_size(const queueParamType q);
void push_back(queueParamTypes &q, ParamType ParamName, const int &size);
ParamType pop_front(queueParamType &q);
std::ostream &operator<<(std::ostream &os, queueParamType q);
  \end{lstlisting}
and in the \texttt{ext-cpp/TasteModel.cpp}:
  \begin{lstlisting}[frame=single]
int get_size(const queueParamType q){
  return q.size();
}

void push_back(queueParamType &q, ParamType ParamName, const int &size){
  if (get_size(q) < size){
    q.push(ParamName);
    std::cout<<"Queuing: "<<ParamName<<std::endl;
  }
  else{
    std::cout<<"Queue full! Element "<<ParamName<< lost"<<std::endl;
  }
}

ParamType pop_front(queueParamType &q){
  ParamTypes res = q.front();
  q.pop();
  std::cout<<"Popping: "<<res <<std::endl;
  return(res);
}

std::ostream &operator<<(std::ostream &os, queueParamType q){
  queueParamType tmp(q); 
  while (!tmp.empty()) {
    os << tmp.front() << " ";
    tmp.pop();
  }
  return os;
}   
  \end{lstlisting}
\end{pt}


%--------------
%port types

\begin{pt}
  The following port type is generated by default:
  \begin{lstlisting}[frame=single]
port type Port()   
  \end{lstlisting}
  For each sporadic provided interface with parameters generate the following port types:
  \begin{lstlisting}[frame=single]
port type ParamTypePort(ParamType ParamName)
port type queueParamTypePort(queueParamType q)
  \end{lstlisting}
\end{pt}


%--------------
%connector types

\begin{pt}
  The following connector type is generated by default:
  \begin{lstlisting}[frame=single]
connector type Sync(Port s, Port t)
  define s t
end
  \end{lstlisting}
  For each sporadic provided interface with parameters generate the following connector types:
  \begin{lstlisting}[frame=single]
connector type SendRecParamType(ParamTypePort s, ParamTypePort r)
  define s r
  on s r
    down { r.ParamName = s.ParamName; }
end

connector type SendRecQueueParamType(queueParamTypePort s, ParamTypePort r)
  define s r
  on s r
    down { r.ParamName = pop_front(s.q); }
end
  \end{lstlisting}
\end{pt}


%--------------
%cyclic interface

\subsubsection{Cyclic provided interface}

\begin{pt}
  A cyclic provided interface $I(period,deadline)$ is modeled as:
  \begin{lstlisting}[frame=single]
atom type TASTE_PI_Cyclic(int period, int deadline)
  clock t unit millisecond

  export port Port sig_out()
  export port Port sig_return()

  place l0, l1, l2

  initial to l0 
  on sig_out 
    from l0 to l1 
    eager
    do { t=0; }

  on sig_return 
    from l1 to l2 
    eager

  on sig_out
    from l2 to l1
    provided (t == period)
    do { t=0; }

  invariant inv1 at l1 provided (t <= deadline)
  invariant inv2 at l2 provided (t <= period) 
end \end{lstlisting}
\end{pt}


%--------------
%sporadic interface

\subsubsection{Sporadic provided interfaces}


\begin{pt}
  A sporadic interface $I(params,miat,deadline,size)$ is modeled as:
  \begin{lstlisting}[frame=single]
atom type TASTE_PI_Sporadic_ParamType(int miat, int deadline, int size)
  clock t unit millisecond
  data ParamType ParamName
  data queueParamType q

  export port ParamTypePort sig_out(ParamName)
  export port Port sig_return()
  export port queueParamTypePort sig_in(q)

  port Port silent()

  place l0, l1, l2

  initial to l0

  on sig_in
    from l0 to l1
    provided(get_size(q)>0)
    eager
    do { t=0; }
  on sig_out
    from l0 to l0
    eager  
    do { push_back(q, ParamName, size); }

  on sig_return
    from l1 to l2
    eager
  on sig_out
    from l1 to l1
    eager  
    do { push_back(q, ParamName, size); }

  on silent
    from l2 to l0
    provided (t == miat)
    eager
    do { t=0; }
  on sig_out
    from l2 to l2
    eager  
    do { push_back(q, ParamName, size); }

  invariant inv1 at l1 provided (t <= deadline)
  invariant inv2 at l2 provided (t <= miat)
end  \end{lstlisting}
\end{pt}


%--------------
%software function

\subsubsection{Function}

\begin{pt}
  A software function $F$ is defined within the pattern:
  \begin{lstlisting}[frame=single]
atom type TASTE_F()
...
end
  \end{lstlisting}
\end{pt}

\begin{pt}
  Every context parameter of a function and every parameter of a required/provided sporadic interface is defined by the pattern:
  \begin{lstlisting}[frame=single]
  data ParamType ParamName   
  \end{lstlisting}
  except for \textit{Timer} variables defined by:
  \begin{lstlisting}[frame=single]
  clock ParamName unit millisecond 
  data int val_ParamName
  \end{lstlisting}
\end{pt}

\begin{pt}
  For every function generate the following internal port:
  \begin{lstlisting}[frame=single]
  port Port silent()
  \end{lstlisting}
\end{pt}


\begin{pt}
  For every cyclic provide interface $I$ owned by $F$ generate:
  \begin{lstlisting}[frame=single]
  export port Port I_in()
  export port Port I_return()
  \end{lstlisting}
\end{pt}

\begin{pt}
  For every sporadic \textit{required} interface $I$ generate:
  \begin{lstlisting}[frame=single]
  export port ParamTypePort I_out(ParamName)
  \end{lstlisting}
\end{pt}

\begin{pt}
  For every sporadic \textit{provided} interface $I$ generate:
  \begin{lstlisting}[frame=single]
   export port ParamTypePort I_in(ParamName)
   export port Port I_return()
  \end{lstlisting}
\end{pt}

\begin{pt}
  For a function $F$ generate the following control locations:
  \begin{lstlisting}[frame=single]
  place loc1, loc2, ..., l1, l2, ...
  \end{lstlisting}
  where \texttt{loc}\textit{i} indexes over the states defined in the SDL state machine of $F$, and 
  \texttt{l}\textit{i} are new locations defined after each action element of F's transitions. % (if they are not followed by a state).
\end{pt}

\begin{pt}
  For a function $F$ with parameters instantiated in an SDL TextSymbol generate:
  \begin{lstlisting}[frame=single]
  initial to loc1
    do { ParamName1 = ParamVal1; 
         ParamName2 = ParamVal2;
         ...
       }
  \end{lstlisting}
\end{pt}

\begin{pt} 
  An element of the SDL state machine is given as follows, where \texttt{li}, \texttt{lj} and \texttt{lk} are elements of the control locations set.
  \begin{itemize}
   \item An SDL Input with value \texttt{sig} a signal is:
      \begin{lstlisting}[frame=single]
  on sig_in
    from li to lj
    eager
      \end{lstlisting}
      An SDL Input with value \texttt{t} a Timer is:
      \begin{lstlisting}[frame=single]
  on silent
    from li to lj 
    provided (t == val_t)
    eager
      \end{lstlisting}
    \item An SDL Task with value \texttt{ParamName := expr} is:
      \begin{lstlisting}[frame=single]
  on silent
    from li to lj
    eager
    do { ParamName = expr; }
      \end{lstlisting}
    \item An SDL Decision with \texttt{decisionCondition} and for all connected DecisionAnswer with \texttt{decisionVal}\textit{i} is:
      \begin{lstlisting}[frame=single]
  on silent
    from li to lj
    provided (decisionCondition == decisionVal1)
    eager
  on silent
    from li to lk
    provided (decisionCondition == decisionVal2)
    eager   
  ...
      \end{lstlisting}
    \item An SDL Output with value \texttt{sig} is:
      \begin{lstlisting}[frame=single]
  on sig_out
    from li to lj
    eager
      \end{lstlisting}
    \item An SDL ProcedureCall with value \texttt{f(params)} where \texttt{f} is an external function is:
      \begin{lstlisting}[frame=single]
  on silent
    from li to lj
    eager
    do { f(params); }
      \end{lstlisting}
	An SDL ProcedureCall with value \texttt{f(params)} where \texttt{f} is an internal-defined function is replaced with 
	the translation of the behavior of \texttt{f} for \texttt{params}. \\
	An SDL ProcedureCall with value \texttt{set\_timer(val, t)} is:
      \begin{lstlisting}[frame=single]
  on silent
    from li to lj
    eager
    do { t = 0; val_t = val; }
      \end{lstlisting}
      An SDL ProcedureCall with value \texttt{reset\_timer(t)} is:
      \begin{lstlisting}[frame=single]
  on silent
    from li to lj
    eager
    do { t = 0; }
      \end{lstlisting}
  \end{itemize}
\end{pt}

\begin{pt}
  In each location of the SDL state machine and for each provided interface $i$ generate the following transition if missing:
  \begin{lstlisting}[frame=single]
  on i_in
    from loci to loci
    eager
  \end{lstlisting}
\end{pt}

\begin{pt}
  At the end of an SDL transition, between the additional state \texttt{li} and the SDL state \texttt{loci}, generate the following:
  \begin{lstlisting}[frame=single]
  on sig_return 
    from li to loci
    eager
  \end{lstlisting}
  where \texttt{sig} is the input at the start of the transition.
\end{pt}


%--------------
%system
\subsubsection{System}

\begin{pt}
  The TASTE IV in instantiated in the pattern:
  \begin{lstlisting}[frame=single]
compound type Syst()
...
end
  \end{lstlisting}
\end{pt}

\begin{pt}
  Each software function $F$ (or $f$ of type $F$) is instantiated by:
  \begin{lstlisting}[frame=single]
  component F f()  
  \end{lstlisting}
\end{pt}

\begin{pt}
  Each cyclic interface $I$ owned by $owner$ is instantied by:
  \begin{lstlisting}[frame=single]
  component TASTE_PI_Cyclic owner_I(val_period, val_deadline)
  \end{lstlisting}
  Each sporadic interface $I$ owned by $owner$  and with parameter of \texttt{ParamType} type is instantiated by:
  \begin{lstlisting}[frame=single]
  component TASTE_PI_Sporadic_ParamType owner_I(val_miat, val_deadline, val_queue) 
  \end{lstlisting}
\end{pt}

\begin{pt}
  The connection between a function $f$ and its cyclic provided interface $I$ is instantiated by:
  \begin{lstlisting}[frame=single]
  connector Sync f_I2f(f_I.sig_out, f.I_in)
  connector Sync f2f_I(f.I_return, f_I.sig_return)
  \end{lstlisting}
\end{pt}

\begin{pt}
  The connection between a function $f$ and the sporadic interface $I$ provided by $f'$ is instantiated by:
  \begin{lstlisting}[frame=single]
  connector SendRecParamType f2f'_I(f.i_out, f'_I.sig_out)
  \end{lstlisting}
\end{pt}

\begin{pt}
  The connection between a function $f$ and its sporadic provided interface $I$ is instantiated by:
  \begin{lstlisting}[frame=single]
   connector SendRecQueueParamType f_I2f(f_I.sig_in, f.I_in)
   connector Sync f2f_I(f.I_return, f_I.sig_return)
  \end{lstlisting}
\end{pt}




\subsection{Example}
\label{subsec:example}

We show in the following how to formalize with (BIP) timed automata a simple producer-consummer example. This system, illustrated in Fig.~\ref{fig:cons_prod}, contains 2 software components {\em Prod} and {\em Cons}.
The {\em Prod} owns a cyclic provided interface {\em step} with a period of 1000ms, and a state variable {\em val} initialized to $0$. 
The {\em Cons} owns a sporadic provided interface {\em comp} with a MIAT of 200ms and which can hold at most 2 requests.
Additionally, {\em comp} stores the integer parameter of these requests.

When activated by {\em step}, {\em Prod} prints the value of {\em val} and then send the request $comp(val)$ to the consummer. The state variables is updated by incrementation, and the producer waits its nnext activation.
The request $comp(val)$ travels the connector and gets stored in the queue of the provided interface {\em comp}. These requests are handled one-by-one by {\em Cons} when the latter is available. 
{\em Cons} is available every 200ms (the value of MIAT) and then it retrieves from the queue (if available) a request. The consummer simply prints the value $val$ of the request and waits for 
its next activation.

Therefore the behavior of the system is the trace: \\
\texttt{
The sent value is: 0 \\
Received value: 0 \\
The sent value is: 1 \\
Received value: 1 \\
The sent value is: 2 \\
Received value: 2 \\
$\cdots$
}


\begin{figure}[h]
  \centering
  \subfloat[Interface view]{\hspace{2ex}\includegraphics[scale=0.4]{figures/iv}\hspace{2ex}\label{fig:cons_prod:iv}} \qquad
  \subfloat[Attributes of the {\em step} cyclic interface]{\includegraphics[scale=0.2]{figures/step}\label{fig:cons_prod:step}} \\
  \subfloat[Attributes of the {\em comp} sporadic interface]{\includegraphics[scale=0.2]{figures/comp_attr}\label{fig:cons_prod:comp_attr}} \qquad
  \subfloat[Property of the {\em comp} sporadic interface]{\includegraphics[scale=0.2]{figures/comp_prop}\label{fig:cons_prod:comp_prop}} \\
  \subfloat[Behavior of the {\em Prod} in SDL]{\includegraphics[scale=0.4]{figures/prod_sm}\label{fig:cons_prod:prod_sm}} \qquad
  \subfloat[Behavior of the {\em Cons} in SDL]{\includegraphics[scale=0.4]{figures/cons_sm}\label{fig:cons_prod:cons_sm}}
  \caption{A full TASTE design of a producer-consummer example.}
  \label{fig:cons_prod}
\end{figure}


We formalize this system as timed automata in BIP syntax. We start by creating the port types the components use for communication.
\begin{lstlisting}
port type Port()
port type intPort(int i)
port type queueIntPort(queueInt q)
\end{lstlisting}


Next, we define 4 types: one for each provided interface and one for each software component.
This is due to BIP allowing to create component types. 
These types can be instantiated several times in a BIP model. In our case each type will be instantiated only once.

The {\em step} provided interface formalization is based on Fig.~\ref{fig:cyclic_pi}, and the result is illustrated in Fig.~\ref{fig:step_form}. 
This is a standard type to be generated only once and instantiated as many times as needed. This is allowed also by the parameterization of period/deadline.

\newsavebox{\firstlisting}
\begin{lrbox}{\firstlisting}% Store first listing
\begin{lstlisting}
atom type TASTE_PI_Cyclic(int period, int deadline)
  clock t unit millisecond

  export port Port sig_out()
  export port Port sig_return()

  place l0, l1, l2

  initial to l0 
  on sig_out 
    from l0 to l1 
    eager
    do { t=0; }

  on sig_return 
    from l1 to l2 
    eager

  on sig_out
    from l2 to l1
    provided (t == period)
    do { t=0; }

  invariant inv1 at l1 provided (t <= deadline)
  invariant inv2 at l2 provided (t <= period) 
end
\end{lstlisting} 
\end{lrbox}

\begin{figure}[!ht]
\subfloat[Graphical representation of the TA]{
  \scalebox{0.65}{
  \begin{tikzpicture}[->,>=stealth',shorten >=1pt,auto,node distance=3.8cm,semithick]
  \node[initial,state,circle split] (l0)               {$l_0$ \nodepart{lower} \textcolor{white}{$t \leq \mathsf{deadline}$}};
  \node[state,circle split]         (l1) [right=15ex of l0] {$l_1$ \nodepart{lower} $t \leq \mathsf{deadline}$};
  \node[state,circle split]         (l2) [below of=l1] {$l_2$ \nodepart{lower} $t \leq \mathsf{period}$};

    
  \path (l0) edge             node[align=center] {${sig\_out}\ /$\\$t=0^{\epsilon}$}    (l1)
        (l1) edge [bend right,left] node {${sig\_return}^{\epsilon}$} (l2)
        (l2) edge [bend right,right] node[align=right] {$[t == \mathsf{period}]\ /$\\ ${sig\_out};$ \\ $t=0^{\epsilon}$}(l1);   
  \end{tikzpicture}
  }
  \label{fig:step_ta}} \qquad \quad
\subfloat[BIP code]{\usebox{\firstlisting}\label{fig:step_bip}}
\caption{Formalization of the {\em step} cyclic interface as TA.}
\label{fig:step_form}
\end{figure}

The {\em Prod}'s formalization is given in Fig.~\ref{fig:prod_form}. The actions $step\_in$ and $step\_return$ are used in the communication with the interface 
{\em step}. The request {\em comp} sent to {\em Cons} gives place to the action $comp\_out(val)$, where $val$ is the state variable of type int. 
The state variable is initialized to $0$ when the component is initialized (i.e., transition from {\em initial} to {\em wait}).
After $step\_in$ is executed, the {\em Prod} component prints the value to be sent, issues a $comp\_out$ and updates its state variable.
Once the behavior modeled by $step\_in$ (in the SDL state machine) is executed (i.e., transition from $l_3$ to $l_4$), the {\em Prod} component 
informs the interface that its computations are finished. If all goes well these computations should finish before the next activation (i.e., period).

\newsavebox{\secondlisting}
\begin{lrbox}{\secondlisting}% Store second listing
\begin{lstlisting}
atom type Prod()
  data int val 

  port Port silent()
  export port Port step_in()
  export port Port step_return()
  export port intPort comp_out(val)

  place wait, l1, l2, l3, l4

  initial to wait
    do { val=0; }

  on step_in
    from wait to l1
    eager
  
  on silent
    from l1 to l2
    eager 
    do { printf("The sent value is: %d\n", val); }	

  on comp_out
    from l2 to l3
    eager

  on silent
    from l3 to l4
    eager
    do { val=val+1; }

  on step_return
    from l4 to wait
    eager
end
\end{lstlisting} 
\end{lrbox}

\begin{figure}[!ht]
\subfloat[Graphical representation of the TA]{
  \scalebox{0.65}{
  \begin{tikzpicture}[->,>=stealth',shorten >=1pt,auto,semithick]
  \node[state,inner sep=1ex] (l1)                    {$wait$};
  \node (l0) [left=9ex of l1]   {start};
  \node[state,inner sep=1ex] (l2) [right=15ex of l1] {$l_1$};
  \node[state,inner sep=1ex] (l3) [below=5ex of l2] {$l_2$};
  \node[state,inner sep=1ex] (l4) [below=5ex of l3] {$l_3$};
  \node[state,inner sep=1ex] (l5) [left=15.8ex of l4] {$l_4$};

  \draw[-latex'] (l0.east) --++ (4ex,0) node[anchor=south,align=center] {val=0} -- (l1.west);  
    
  \path (l1) edge             node[align=center] {${step\_in}^{\epsilon}$}    (l2)
        (l2) edge [right] node[align=left] {$printf('Sent\ value: \%d', val)^{\epsilon}$} (l3)
        (l3) edge [right] node[align=left] {${comp\_out}^{\epsilon}$} (l4)
        (l4) edge node[align=center] {$val = val + 1^\epsilon$} (l5)
        (l5) edge [left] node[align=right,xshift=-1ex] {${step\_return}^{\epsilon}$}(l1);   
  \end{tikzpicture}
  }
  \label{fig:prod_ta}} \quad
\subfloat[BIP code]{\usebox{\secondlisting}\label{fig:prod_bip}}
\caption{Formalization of the {\em Prod} software function as TA.}
\label{fig:prod_form}
\end{figure}


BIP allows using external C++ code in the component types. We make use of this mechanism to represent the queue of a sporadic provided interface 
as well as the {\em append}, {\em pop}, {\em length} functions. Therefore we define the type \texttt{queueInt} to store the received integer values, 
and the functions \texttt{push\_back}, \texttt{pop\_front} and \texttt{get\_size} respectively. We encode in the \texttt{push\_back} function the appending 
of an element only if the queue is not full, otherwise the element is lost. Then the TA corresponding to the {\em comp} sporadic interface provided in 
Fig.~\ref{fig:comp_form} has less transitions than the pattern from Fig.~\ref{fig:cyclic_pi}. The size of the queue is given as a parameter to the component type, 
as well as the miniminal inter-arrival time and deadline.
The action $sig\_out$ models the interaction with {\em Prod}, and $sig\_in$ and $sig\_return$ the interactions with {\em Cons}.

\newsavebox{\thirdlisting}
\begin{lrbox}{\thirdlisting}% Store second listing
\begin{lstlisting}
atom type TASTE_PI_Sporadic_int(int miat, int deadline, int size)
  clock t unit millisecond
  data int val 
  data queueInt q

  port Port silent()
  export port intPort sig_out(val)
  export port Port sig_return()
  export port queueIntPort sig_in(q)

  place l0, l1, l2 

  initial to l0
    do { val=0; }

  on sig_in
    from l0 to l1
    provided (get_size(q)>0)
    eager
    do { t=0; } 
  on sig_out
    from l0 to l0
    eager  
    do { push_back(q, val, size); }

  on sig_return
    from l1 to l2
    eager
  on sig_out
    from l1 to l1
    eager  
    do { push_back(q, val, size); }

  on silent
    from l2 to l0
    provided (t == miat)
    eager
    do { t=0; }
  on sig_out
    from l2 to l2
    eager  
    do { push_back(q, val, size); }

  invariant inv1 at l1 provided (t <= deadline)
  invariant inv2 at l2 provided (t <= miat)
end\end{lstlisting} \end{lrbox}

\begin{figure}[!ht]
\subfloat[Graphical representation of the TA]{
  \scalebox{0.6}{
  \begin{tikzpicture}[->,>=stealth',shorten >=1pt,auto,node distance=4cm,semithick]
    \node[state,circle split] (l0)               {$l_0$ \nodepart{lower} \textcolor{white}{$t \leq deadline$}};
    \node[state,circle split] (l1) [below of=l0] {$l_1$ \nodepart{lower} $t \leq \mathsf{deadline}$};
    \node[state,circle split,inner sep=1.5ex] (l2) [below= 8ex of l1] {$l_2$ \nodepart{lower} $t \leq \mathsf{miat}$};
    \node (l3) [left=9ex of l0] {start};
    
    \draw[-latex'] (l3.east) --++ (4ex,0) node[anchor=south,align=center] {val=0} -- (l0.west);     
    \path (l0) edge [loop above] node[right,align=left,xshift=2ex] {$sig\_out(val);$\\$push\_back(q, val, \mathsf{size})^{\epsilon}$} (l0)
	  (l0) edge node[align=left,xshift=2ex] {$[get\_size(q) > 0]\ /$\\$sig\_in(pop\_front(q));$\\$t=0^{\epsilon}$} (l1)
	  (l1) edge node[xshift=1ex] {$sig\_return^{\epsilon}$} (l2)
	  (l1) edge [loop right,in=0,out=20,min distance=10mm,align=left] node {$sig\_out(val);$\\$push\_back(q, val, \mathsf{size})^{\epsilon}$} (l1)
	  (l2) edge [bend left=30] node[align=right] {$[t = \mathsf{miat}]\ /$\\$t=0^{\epsilon}$} (l0)
	  (l2) edge [loop below] node[right,pos=0.2,align=left] {$sig\_out(val);$\\$push\_back(q, val, \mathsf{size})^{\epsilon}$}(l2);
  \end{tikzpicture}}
  \label{fig:comp_ta}} \qquad
\subfloat[BIP code]{\usebox{\thirdlisting}\label{fig:comp_bip}}
\caption{Formalization of the {\em comp} sporadic interface as TA.}
\label{fig:comp_form}
\end{figure}

The {\em Cons} component type illustrated in Fig.~\ref{fig:cons_form} removes elements 1-by-1 from the queue and prints the received values.

\newsavebox{\fourthlisting}
\begin{lrbox}{\fourthlisting}% Store second listing
\begin{lstlisting}
atom type Cons()
  data int val

  port Port silent()
  export port intPort comp_in(val)
  export port Port comp_return()

  place wait, l1, l2

  initial to wait
    do { val=0; }

  on comp_in
    from wait to l1
    eager
  
  on silent
    from l1 to l2
    do { printf("Received value: %d\n", val);}

  on comp_return
    from l2 to wait
    eager
end
\end{lstlisting} 
\end{lrbox}

\begin{figure}[!ht]
\subfloat[Graphical representation of the TA]{
  \scalebox{0.65}{
  \begin{tikzpicture}[->,>=stealth',shorten >=1pt,auto,semithick]
  \node[state,inner sep=1ex] (l1)                    {$wait$};
  \node (l0) [left=9ex of l1]   {start};
  \node[state,inner sep=1ex] (l2) [right=15ex of l1] {$l_1$};
  \node[state,inner sep=1ex] (l3) [below left= 7ex and 7ex of l2] {$l_2$};

  \draw[-latex'] (l0.east) --++ (4ex,0) node[anchor=south,align=center] {val=0} -- (l1.west);  
    
  \path (l1) edge node[align=center] {$comp\_in^\epsilon$}    (l2)
        (l2) edge node[align=left] {$printf('Received\ value: \%d', val)^{\epsilon}$} (l3)
        (l3) edge node[align=right] {$comp\_return^{\epsilon}$} (l1);
  \end{tikzpicture}}
  \label{fig:cons_ta}} \qquad
\subfloat[BIP code]{\usebox{\fourthlisting}\label{fig:cons_bip}}
\caption{Formalization of the {\em Cons} software function as TA.}
\label{fig:cons_form}
\end{figure}

Next we define the interaction types between components. We have three types: one corresponds only to synchronization, while the other two also exchange data.
\begin{lstlisting}
connector type Sync(Port s, Port t)
  define s t
end 

connector type SendRecInt(intPort s, intPort r)
  define s r
  on s r
    down {r.i = s.i;}
end 

connector type SendRecQueueInt(queueIntPort s, intPort r)
  define s r
  on s r
    down {r.i = pop_front(s.q);}
end \end{lstlisting}

Finally the system is created with the following instatiation.
\begin{lstlisting}
compound type Syst()
  component Prod prod()
  component TASTE_PI_Cyclic prod_step(1000,1000)
  component TASTE_PI_Sporadic_int cons_comp(200,200,2)

  connector Sync prod_step2prod(prod_step.sig_out, prod.step_in)
  connector Sync prod2prod_step(prod.step_return, prod_step.sig_return)

  connector SendRecInt prod2coms_compCom1(prod.comp_out, cons_comp.sig_out)

  connector SendRecQueueInt cons_comp2cons(cons_comp.sig_in, cons.comp_in)
  connector Sync cons2cons_comp(cons.comp_return, cons_comp.sig_return
end  
\end{lstlisting}

The system can be now compiled and executed with the BIP engines. The previous trace is part of the traces provided by the BIP engines.

\section{Implementation}
\label{sec:implem}

The implementation of the TASTE to BIP model transformation requires getting access to the various AADL and SDL constructs that define the TASTE input model.
According to the technologies already available inside the current TASTE tool-chain, two main options can be considered for parsing the AADL subset of the TASTE model:
The Ocarina python binding
The LMP AADL toolbox used in the IV, DV and CV editors

The LMP (Logic Model Processing) technology [12,13] is a generic approach to handle heterogeneous models and meta-models. It consists of representing each meta-model by a list of Prolog predicates and expressing each model processing function by a set of Prolog rules. Figure 4 shows the general principles of an LMP connector.

All the components of the LMP toolbox that are required to process AADL models are already included into the TASTE tool-chain. One of the benefits of this approach is that it allows for a declarative and formal implementation of the transformation rules, which makes it appropriate for certification processes. For example, verification tools developed with LMP have been qualified by Airbus according to DO 178 recommendations for the A380 and A350 programs.

The LMP implementation of the Taste to BIP transformation has been split in three separate modules. The Main module only acts as a launcher, whereas the TASTE module provides access to the TASTE Interface View constructs and the BIP module defines the BIP entities to be produced. A fourth module will be added to give access to the SDL model associated with each TASTE function

The following fragments of the transformation illustrate how the translation requirements defined in Chapter 2.4 are implemented in a quite straightforward way in prolog.
TR 8.  A software function F is defined within the pattern:
atom type TASTE\_F()
…
end

insertBIPAtomTypes(IV) :- 
    …
    isTasteFunction(F,P,T,I,'terminal'), insertBIPFunctionType(IV,F,P,T,I)
    …

For each TASTE Function, we apply the proposed BIP pattern

insertBIPFunctionType(IV,Label,Pkg,Type,Impl) :- 
    write('  atom type '), write(Label), write('()'), nl, 
    insertBIPData(Pkg,Type), nl, 
    insertBIPPort(Pkg,Type), nl, 
    write('  end'), nl.

A Taste Function is defined by an AADL System subcomponent. If it does not contain itself a System subcomponent, it is terminal in the Functions hierarchy.

%isTasteFunction(Label,Pkg,Type,Impl,Kind) :- 
%    isSubcomponent(_,_,_,Label,'SYSTEM',C,_,_,_), 
%    splitReference(C,Pkg,Type,Impl), 
%    ( isSubcomponent(Pkg,Type,Impl,_,'SYSTEM',_,_,_,_) -> 
%      Kind = 'non-terminal';
%      Kind = 'terminal' ).
TR 11.  For every cyclic provided interface I owned by F generate:
  export port Port I\_in()
  export port Port I\_return()

For each TASTE cyclic Provided Interface, we apply the proposed BIP pattern

insertBIPPort(Pkg,Type) :- 
%    isTastePI(Pkg,Type,L,_,_,'cyclic',_,_,_,_), 
    write('    export port Port '), write(L), write('\_in()'), nl, 
    write('    export port Port '), write(L), write('\_return()'), nl, 
    fail.

A TASTE Provided Interface is defined by an AADL Provides Subprogram Access feature. The various attributes are defined by AADL properties.

isTastePI(PPkg,PType,Label,Param,Type,Kind,Period,Deadline,Wcet,QSize) :- 
%    isFeature('ACCESS',PPkg,PType,F,'PROVIDES','SUBPROGRAM',C,_,_,_), 
    getPILabel(PPkg,PType,F,Label), 
    getPIKind(PPkg,PType,F,Kind), 
    getPIPeriod(PPkg,PType,F,Period), 
    getPIDeadline(PPkg,PType,F,Deadline), 
    splitReference(C,P,T,I), 
    getPIWcet(PPkg,PType,F,P,T,I,Wcet), 
%    getPIRIParam(P,T,Param,'IN',_,Type,_), 
    getPIQueueSize(P,T,QSize).

TR 12.  For every sporadic required interface I generate:
  export port ParamTypePort I\_out(ParamName)

For each TASTE Required Interface, we apply the proposed BIP pattern

insertBIPPort(Pkg,Type) :- 
%    isTasteRI(Pkg,Type,L,P,_), 
    write('    export port intPort '), write(L), 
%   	write('_out('), write(L), write('_'), write(P), write(')'), nl, 
    fail.

A TASTE Required Interface is defined by an AADL Requires Subprogram Access feature. 

isTasteRI(PPkg,PType,Label,Param,Type) :- 
%    isFeature('ACCESS',PPkg,PType,F,'REQUIRES','SUBPROGRAM',C,_,_,_), 
%    splitReference(C,P,T,_), 
    getRILabel(PPkg,PType,F,Label), 
%    getPIRIParam(P,T,Param,'IN',_,Type,_).

TR 13.  For every sporadic provided interface I generate:
  export port ParamTypePort I\_in(ParamName)
  export port Port I\_return()

For each TASTE sporadic Provided Interface, we apply the proposed BIP pattern

insertBIPPort(Pkg,Type) :- 
%    isTastePI(Pkg,Type,L,P,_,'sporadic',_,_,_,_), 
    write('    export port intPort '), write(L), 
%    	write('_in('), write(L), write('_'), write(P), write(')'), nl, 
%    write('    export port Port '), write(L), write('_return()'), nl, 
    fail.

Note that we reuse here the same rule isTastePI that was presented above.

The other translation rules defined in Chapter 2.4 are implemented in a similar way. In the current state of the development, the main missing aspects in the transformation are the precise parameter type management (DataView) and the function behavior expressed in SDL.
3.2.2. Integration into the TASTE editor
All the transformation rules are compiled into a single Prolog byte code file named taste2bip.sbp that simply needs to be added to the config/plugins directory of the TASTE editor installation.
Additionally, to facilitate the access to this new feature from within the editor, a new script called taste2bip.tcl must be placed inside the config/externalTools directory of the TASTE editor installation.
No other action is required. A new Tools menu item is then available to activate the BIP model generation from the currently loaded TASTE Interface View model, as shown in the following screenshot.

\section{Conclusion}
\label{sec:concl}

We present in this document the current status of the TASTE to BIP transformation. First we describe a generic method for translating a language to BIP. Then we apply this method to the TASTE language.
We present the TASTE language and the subset we consider for transformation. This subset consists of mainly data views and flat interface views where the behavior is modeled by SDL state machines. On this subset we impose a set of well-formedness rules such that the design is both structurally and semantically correctly defined. Some of these rules are already applied by the TASTE editors, and we state them here for convenience. 
We briefly describe the BIP language. We consider the timed automata modeling of BIP which defines the semantics of TASTE designs. Then we detail the transformation rules for each TASTE element as BIP patterns to be generated. These patterns fall in two categories: either to be generated only once and instantiated multiple times, or to be generated specifically for a component. In the first case the patterns are either fixed and parameters allow to obtain components with different features, or they have to be indexed by types (e.g., generate the pattern of sporadic interfaces for each data type they can transfer independently). A toy example of a Producer-Consumer illustrates the BIP model generation and validates the transformation rules semantically, i.e., the simulated behavior of the TASTE design is a simulated behavior of the BIP model.
Finally, we describe the current prototype implementing the transformation. Two options are available for obtaining the modeling elements of a TASTE design: Ocarina with python bindings and the LMP AADL toolbox. We motivate the usage of LMP AADL by presenting the advantages and shortcomings of each. The preliminary tool architecture and the implementation of several transformation rules are illustrated. We equally show the integration of the TASTE2BIP tool in the TASTE editors.
Future work will focus on two directions. First, the implementation of the current transformation rules will be finalized. Secondly, the semantics of hierarchical views will be studied and transformation rules will be proposed in this case. Additionally, more structuring of the BIP model will be studied (e.g., compounds containing a function and all its provided interfaces) and the rules will be adapted accordingly.

%\newpage
\clearpage
\bibliographystyle{abbrv}
\bibliography{report}

%\newpage
%\clearpage
\appendix
\section{Full BIP Model of The Producer-Consummer Example}
\label{sec:annex}

\subsection{The External C++ Code}
\lstinputlisting[frame=single]{code/ext-cpp/TasteExample.hpp}
\lstinputlisting[frame=single]{code/ext-cpp/TasteExample.cpp}

\subsection{The BIP Model}
\lstinputlisting[frame=single]{code/TasteExampleParam.bip}


\end{document}
